/****************************************************************************/
/*                                                                          */
/*                                  GAME                                    */
/*                                                                          */
/****************************************************************************/

#include "Game.hpp"

/****************************************************************************/
/*                             INITIALSATION                                */
/****************************************************************************/
Game::Game()
{
	scene = SCENE_MENU;

	sub_x = 0;
	sub_y = 50;
	sub_vie = 100;
	sub_torpille_cmpt = 0;
	sub_bruit = 0;
	score = 0;
	effacer_texte();
	for (int i=0; i<MAX_ENNEMIS; i++)
	{
		ennemis[i].vie = 0;
	}
	for (int i=0; i<MAX_TORPILLES; i++)
	{
		torpilles[i].compteur = 0;
	}
}


/****************************************************************************/
/*                       ajoute un sous marin ennemi                        */
/****************************************************************************/
void Game::ajouter_ennemi(float x, float y)
{
	for (int i=0; i<MAX_ENNEMIS; i++)
	{
		Sub *ennemi = &ennemis[i];
		if (ennemi->vie == 0)
		{
			ennemi->x = x;
			ennemi->y = y;
			ennemi->vie = 100;
			return;
		}
	}
}


/****************************************************************************/
/*                       ajoute une torpille active                         */
/****************************************************************************/
void Game::ajouter_torpille(float x, float y, float vx, float vy, bool ennemi)
{
	for (int i=0; i<MAX_TORPILLES; i++)
	{
		Torpille *torpille = &torpilles[i];
		if (torpille->compteur == 0)
		{
			torpille->x = x;
			torpille->y = y;
			torpille->vx = vx;
			torpille->vy = vy;
			torpille->compteur = 400;
			torpille->ennemi = ennemi;
			torpille->detecte = false;
			return;
		}
	}
}


/****************************************************************************/
/*                  ajoute une ligne de texte à la suite                    */
/****************************************************************************/
void Game::ajouter_texte(unsigned char* texte)
{
	memcpy(&texte_ligne1, &texte_ligne2, 15);
	memcpy(&texte_ligne2, &texte_ligne3, 15);
	memcpy(&texte_ligne3, &texte_ligne4, 15);
	memcpy(&texte_ligne4, texte, 15);
}


/****************************************************************************/
/*                    efface toutes les lignes de texte                     */
/****************************************************************************/
void Game::effacer_texte()
{
	for (int i=0; i<4; i++)
	{
		ajouter_texte(" ");
	}
}





