/****************************************************************************/
/*                                                                          */
/*                            SCENE COMMANDE                                */
/*                                                                          */
/****************************************************************************/


#include "Scene_Commande.hpp"
extern Game game;


/****************************************************************************/
/*                            INITIALSATION                                 */
/****************************************************************************/
Scene_Commande::Scene_Commande()
{
	frame_gris = false;

	radar_angle = 0;
	radar_vitesse = 0.15;// 0.15
	radar_zoom = 0.5;
	for (int i=0; i<MAX_POINT_RADAR; i++)
	{
		radar_points[i].compteur = 0;
	}
	fond = 100;
	monter = 0;
	bouger = 0;
	hitbox = 4;
	trembler_ecran = -1;
	ennemi_ok_x = game.sub_x;
	bonus_dep = 0;
	histoire = 0;

	//game.ajouter_ennemi(90, 30);
	//game.ajouter_ennemi(80, 70);

	ajouter_texte("Bonjour");
	ajouter_texte("capitaine");
	ajouter_texte("nous sommes");
	ajouter_texte("pret");
}


/****************************************************************************/
/*                            lance la scene                                */
/****************************************************************************/
void Scene_Commande::start()
{
	while(game.scene == SCENE_COMMANDE)
	{
		// mise à jour des graphismes
		graphics_update();
		// mise à jour du clavier
		input_update();
		// gestion du jeu
		engine_update();
		// régulation des fps
		time_set_fps(FPS);
	}
}


/****************************************************************************/
/*                        mets à jour les graphismes                        */
/****************************************************************************/
void Scene_Commande::graphics_update()
{
	frame_gris = !frame_gris;

	ML_clear_vram();

	// radar
	ML_filled_circle(32, 32, 32, ML_BLACK);

	// afichage de la suface et du fond
	for (int i=1; i<32/radar_zoom; i++)
	{
		int dy = 32 - (i + game.sub_y) * radar_zoom;
		if (-320 < dy and dy < 320)
		{
			int racine = sqrtf(dy*(64-dy));
			ML_horizontal_line(dy, 32-racine, 32+racine, ML_WHITE);
		}
	}
	
	int dy = 32 - (game.sub_y - fond) * radar_zoom;
	if (0 < dy and dy < 64)
	{
		int racine = sqrtf(dy*(64-dy));
		ML_horizontal_line(dy, 32-racine, 32+racine, ML_WHITE);
	}

	// radar
	int radar_trait_x = 32 + 31 * cosf(radar_angle);
	int radar_trait_y = 32 + 31 * sinf(radar_angle);
	ML_line(32, 32, radar_trait_x, radar_trait_y, ML_XOR);
	for (int i=0; i<MAX_POINT_RADAR; i++)
	{
		Point *point = &radar_points[i];
		if (point->compteur > 0 and (point->compteur < 10 and frame_gris or point->compteur >= 10))
		{
			point->compteur -= 1;
			ML_pixel(32 + point->x - game.sub_x * radar_zoom, 
					 32 + point->y - game.sub_y * radar_zoom, ML_WHITE);
		}
	}

	// infos
	ML_bmp_8_or(sprite_coeur, 69, 1);
	ML_bmp_8_or(sprite_bruit, 99, 1);
	ML_bmp_8_or(sprite_torpille, 69, 10);
	if (monter > 0)
	{
		ML_bmp_8_or(sprite_monter, 99, 10);
	} else
	{
		ML_bmp_8_or(sprite_descendre, 99, 10);
	}
	char str[10];
	sprintf(str, "%i", game.sub_vie);
	PrintMini(78, 2, (unsigned char*)str, MINI_OVER);
	sprintf(str, "+%idB", game.sub_bruit);
	PrintMini(108, 2, (unsigned char*)str, MINI_OVER);
	if (game.sub_torpille_cmpt > 0)
	{
		sprintf(str, "%is", game.sub_torpille_cmpt * FPS / 128 + 1);
	} else
	{
		sprintf(str, "pret");
	}
	PrintMini(78, 11, (unsigned char*)str, MINI_OVER);
	sprintf(str, "%i m", int(game.sub_y));
	PrintMini(108, 11, (unsigned char*)str, MINI_OVER);

	// barre de mouvement
	ML_horizontal_line(23, 69, 125, ML_BLACK);
	for (int i=0; i< 5; i++)
	{
		int x = 80 + 10*i - int(game.sub_x) % 10;
		ML_vertical_line(x, 22, 25, ML_BLACK);
	}

	// score
	sprintf(str, "score: %i", game.score);
	PrintMini(70, 30, (unsigned char*)str, MINI_OVER);

	// texte
	ML_bmp_or(sprite_parole, 56, 54, 10, 9);
	PrintMini(69, 39, (unsigned char*)game.texte_ligne1, MINI_OVER);
	PrintMini(69, 45, (unsigned char*)game.texte_ligne2, MINI_OVER);
	PrintMini(69, 51, (unsigned char*)game.texte_ligne3, MINI_OVER);
	PrintMini(69, 57, (unsigned char*)game.texte_ligne4, MINI_OVER);
	ML_rectangle(67, 37, 127, 63, 1, ML_BLACK, ML_TRANSPARENT);

	if (trembler_ecran > 0)
	{
		int scroll = 5 * sinf(trembler_ecran);
		trembler_ecran -= 0.5;
		ML_horizontal_scroll(scroll);
		if (scroll > 0)
		{
			ML_rectangle(0, 0, scroll-1, 64, 0, ML_TRANSPARENT, ML_WHITE);
		} else
		{
			ML_rectangle(128+scroll, 0, 128, 64, 0, ML_TRANSPARENT, ML_WHITE);
		}
	}

	ML_display_vram();
}


/****************************************************************************/
/*                        mets à jour la scene                              */
/****************************************************************************/
void Scene_Commande::engine_update()
{
	radar_angle += radar_vitesse;
	if (radar_angle > 6.28) radar_angle -= 6.28;


	// deplacement
	if (input_press(K_RIGHT))
	{
		game.sub_x += 0.15 + bonus_dep;
		bouger += 3 - bouger / 40;
	}
	if (input_press(K_LEFT) and game.sub_x > 0)
	{
		game.sub_x -= 0.15 + bonus_dep;
		bouger += 3 - bouger / 40;
	}
	if (input_press(K_UP) and game.sub_y > 0)
	{
		game.sub_y -= 0.2 + bonus_dep;
		monter = 10;
		bouger += 3 - bouger / 30;
	}
	if (input_press(K_DOWN) and game.sub_y < fond - 5)
	{
		game.sub_y += 0.25 + bonus_dep;
		monter = 0;
		bouger += 3 - bouger / 20;
	}
	if (monter > 0) monter -= 1;
	if (bouger > 100) bouger = 100;
	if (bouger > 0) bouger -= 1;
	game.sub_bruit = 40 * bouger / 100;


	// tirer
	if (input_trigger(K_SHIFT))
	{
		if (game.sub_torpille_cmpt == 0)
		{
			game.ajouter_torpille(game.sub_x, game.sub_y, 0.3, 0, false);
			game.sub_torpille_cmpt = 90;
			if (game.sub_bruit < 10) game.sub_bruit = 10;
			ajouter_texte("torpille partie");
		} else
		{
			ajouter_texte("pas pret");
		}
	}
	if (game.sub_torpille_cmpt > 0)
	{
		game.sub_torpille_cmpt -= 1;
	}


	// mise a jour des objets
	for (int i=0; i<MAX_TORPILLES; i++)
	{
		Torpille *torpille = &game.torpilles[i];
		if (torpille->compteur > 0)
		{
			torpille->x += torpille->vx;
			torpille->y += torpille->vy;
			torpille->compteur -= 1;
			if (torpille->y > fond or torpille->y < 0)
			{
				torpille->compteur = 0;
			}

			// test collision torpille
			if (torpille->ennemi == false)
			{
				for (int i=0; i<MAX_ENNEMIS; i++)
				{
					Sub *ennemi = &game.ennemis[i];
					if (ennemi->vie > 0)
					{
						if (ennemi->x-hitbox < torpille->x and torpille->x < ennemi->x + hitbox and
							ennemi->y-hitbox < torpille->y and torpille->y < ennemi->y + hitbox)
						{
							ennemi->vie = 0;
							torpille->compteur = 0;
							if (bouger < 80) bouger = 80;
							ajouter_texte("sub touche");
							ajouter_texte("bien joue");
							game.score += 1;
						}
					}
				}
			} else 
			{
				if (game.sub_x-hitbox < torpille->x and torpille->x < game.sub_x + hitbox and
					game.sub_y-hitbox < torpille->y and torpille->y < game.sub_y + hitbox)
				{
					game.sub_vie -= 25;
					torpille->compteur = 0;
					if (bouger < 80) bouger = 170;
					trembler_ecran = 6.1415 * 3;

					// perdu
					if (game.sub_vie <= 0)
					{
						game.scene = SCENE_MENU;
					}

					ajouter_texte("BOOM !!!");
					ajouter_texte("on est touche");
				}
			}

			// affichage des points
			int dx = (torpille->x - game.sub_x) * radar_zoom;
			int dy = (torpille->y - game.sub_y) * radar_zoom;
			if (radar_scan(dx, dy))
			{
				ajouter_point_radar(dx, dy);
			}
		}
	}

	for (int i=0; i<MAX_ENNEMIS; i++)
	{
		Sub *ennemi = &game.ennemis[i];
		if (ennemi->vie > 0)
		{
			// fait attaquer l'ennemi
			ennemi_attaquer(ennemi);

			// affichage des points
			int dx = (ennemi->x - game.sub_x) * radar_zoom;
			int dy = (ennemi->y - game.sub_y) * radar_zoom;
			if (radar_scan(dx, dy))
			{
				// premiere detection
				if (ennemi->detecte == false)
				{
					ennemi->detecte = true;
					ajouter_texte("sub approche");
				}
				ajouter_point_radar(dx, dy);
				ajouter_point_radar(dx-1, dy);
				ajouter_point_radar(dx+1, dy);
				ajouter_point_radar(dx, dy+1);
				ajouter_point_radar(dx-1, dy+1);
				ajouter_point_radar(dx+1, dy+1);
			}
		}
	}

	// ajouter un ennemi
	int critere = -ennemi_ok_x + game.sub_x + 2 * game.score;
	if (critere > 40)
	{
		int critere2 = int(game.sub_x + game.sub_y + game.sub_bruit) % 3;
		if (critere2 == 0)
		{
			game.ajouter_ennemi(game.sub_x + int(game.sub_x) % 10 + 60, fond/2 - 20 + int(game.sub_x) % 40);
		}
		if (critere2 == 1 or game.score > 5)
		{
			game.ajouter_ennemi(game.sub_x + int(game.sub_x + game.sub_bruit) % 10 + 60, fond/2 - 30 + int(game.sub_x + game.sub_y) % 40);
		}
		if (critere2 == 2 or game.score > 15)
		{
			game.ajouter_ennemi(game.sub_x + int(game.sub_x + game.sub_bruit) % 20 + 60, fond/2 - 20 + int(game.sub_x) % 65);
		}
		ennemi_ok_x = game.sub_x;
	}

	// bonus
	if (game.score == 5 and bonus_dep < 0.03)
	{
		bonus_dep= 0.02;
		game.effacer_texte();
		ajouter_texte("BONUS");
		ajouter_texte("deplacement");
		ajouter_texte("rapide");
	}
	if (game.score == 15 and bonus_dep < 0.05)
	{
		bonus_dep = 0.04;
		game.effacer_texte();
		ajouter_texte("BONUS");
		ajouter_texte("deplacement");
		ajouter_texte("rapide");
	}
	if (game.score == 10 and radar_vitesse < 0.16)
	{
		radar_vitesse = 0.18;
		game.effacer_texte();
		ajouter_texte("BONUS");
		ajouter_texte("radar plus");
		ajouter_texte("rapide");
	}
	if (game.score == 25 and radar_vitesse < 0.19)
	{
		radar_vitesse = 0.2;
		game.effacer_texte();
		ajouter_texte("BONUS");
		ajouter_texte("radar plus");
		ajouter_texte("rapide");
	}
	if (game.score == 1 and histoire == 0)
	{
		ajouter_texte("continuons");
		ajouter_texte("vers la");
		ajouter_texte("droite");
		histoire = 1;
	}

	// texte
	compteur_texte -= 1;
	if (compteur_texte == 0)
	{
		ajouter_texte(" ");
	}
}


/****************************************************************************/
/*       ajoute des points a afficher temporairement sur le radar           */
/****************************************************************************/
void Scene_Commande::ajouter_point_radar(int x, int y)
{
	for (int i=0; i<MAX_POINT_RADAR; i++)
	{
		Point *point = &radar_points[i];
		if (point->compteur == 0)
		{
			point->x = x + game.sub_x * radar_zoom;
			point->y = y + game.sub_y * radar_zoom;
			point->compteur = 30;
			return;
		}
	}
}


/****************************************************************************/
/*        verifie si le radar a le bon angle pour detecter l'objet          */
/****************************************************************************/
bool Scene_Commande::radar_scan(int dx, int dy)
{
	if (dx * dx + dy * dy < 32 * 32 and (dx != 0 or dy != 0))
	{
		float angle = atan2f(dy, dx);
		angle = (angle < 0 ? angle + 6.28 : angle);
		angle = angle - radar_angle;
		if (angle < 0) angle = angle + 6.28;
		if (angle < radar_vitesse)
		{
			return true;
		}
	}
	return false;
}


/****************************************************************************/
/*                       ajoute un nouveau message                          */
/****************************************************************************/
void Scene_Commande::ajouter_texte(unsigned char* texte)
{
	game.ajouter_texte(texte);
	compteur_texte = 40;
}


/****************************************************************************/
/*            gere l'attaque de l'ennemi et envoie une torpille             */
/****************************************************************************/
void Scene_Commande::ennemi_attaquer(Sub *ennemi)
{
	ennemi->torpille_cmpt -= 1;
	if (ennemi->torpille_cmpt <= 0)
	{
		int dx = game.sub_x - ennemi->x;
		int dy = game.sub_y - ennemi->y;
		float d = sqrtf(dx * dx + dy * dy);
		if (d < 70 or (d < 90 and game.sub_bruit > 10))
		{
			float vx = 0.3 * dx / d;
			float vy = 0.3 * dy / d;
			ennemi->torpille_cmpt = 250 - 3 * game.score;
			game.ajouter_torpille(ennemi->x, ennemi->y, vx, vy, true);
		}
	}
}





















