/****************************************************************************/
/*                                                                          */
/*                            SCENE COMMANDE                                */
/*                                                                          */
/****************************************************************************/


#ifndef DEF_SCENE_COMMANDE
#define DEF_SCENE_COMMANDE


extern "C"
{
	#include "MonochromeLib.h"
	#include "Input.h"
	#include "Time.h"
	#include "mathf.h"
}
#include "Commun.hpp"
#include "Game.hpp"
#include "Sub.hpp"
#include "Structures.hpp"
#include "Debug.hpp"


// sprite utilises dans cette scene
const unsigned char sprite_torpille[]={0x0, 0x0, 0x0, 0x9e, 0xff, 0x9e, 0x0, 0x0};
const unsigned char sprite_parole[]={0x48, 0x3f, 0xcc, 0x3f, 0xcc, 0x3f, 0x8e, 0xbf, 
	0x8c, 0x7f, 0xfd, 0x7f, 0xfd, 0x7f, 0x78, 0x7f, 0x70, 0xbf};
const unsigned char sprite_coeur[]={0x0, 0x6c, 0xfe, 0xfe, 0xfe, 0x7c, 0x38, 0x10};
const unsigned char sprite_descendre[]={0x10, 0x10, 0x10, 0x10, 0x54, 0x38, 0x10, 0x0};
const unsigned char sprite_monter[]={0x0, 0x10, 0x38, 0x54, 0x10, 0x10, 0x10, 0x10};
const unsigned char sprite_bruit[]={0x8, 0x24, 0x12, 0x4a, 0x2a, 0x4a, 0x12, 0x24};


class Scene_Commande
{
public:
	Scene_Commande();
	void start();
	void graphics_update();
	void engine_update();
	void ajouter_point_radar(int x, int y);
	bool radar_scan(int dx, int dy);
	void ajouter_texte(unsigned char* texte);
	void ennemi_attaquer(Sub *ennemi);
public:
	bool frame_gris;
	float radar_vitesse;
	float radar_angle;
	float radar_zoom;
	Point radar_points[MAX_POINT_RADAR];
	int fond;
	int monter;
	int bouger;
	float hitbox;
	int compteur_texte;
	float trembler_ecran;
	int ennemi_ok_x;
	float bonus_dep;
	int histoire;
};

#endif
